#import <QCGLObject.h>
#import <QCPBuffer.h>

@interface QCGLImage : QCGLObject
{
	int _type;
	unsigned int _pixelsWide;
	unsigned int _pixelsHigh;
	float _pixelsAspectRatio;
	unsigned int _textureName;
	unsigned int _textureTarget;
	unsigned int _textureLevels;
	float _textureMatrix[16];
	unsigned int _textureFlags;
	float _textureAnisotropy;
	int _textureWrapping;
	int _textureFiltering;
	CDAnonymousStruct4 _textureBorderColor;
	void *_bufferAddress;
	unsigned int _bufferRowBytes;
	unsigned int _bufferPixelComponents;
	unsigned int _bufferPixelSize;
	unsigned int _bufferFormat;
	unsigned int _bufferType;
	void *_bufferCallback;
	void *_bufferUserInfo;
	BOOL _bufferUploaded;
	BOOL _bufferDownloaded;
	CIImage *_ciImage;
	QCPBuffer *_ciImagePBuffer;
	unsigned int _ciImageTextureName;
	NSData *_bufferData;
	NSData *_rawData;
	struct CGImage *_cgImage;
	NSImage *_nsImage;
	void *_scratchBufferAddress;
	unsigned char _saveEnabled;
	void *_unused3[4];
}

- (void)_finalize_QCGLImage;
- (void)finalize;
- (void)dealloc;
- (unsigned int)pixelsWide;
- (unsigned int)pixelsHigh;
- (float)pixelsAspectRatio;
- (unsigned long)textureTarget;
- (const float *)textureMatrix;
- (unsigned int)textureMipmapLevels;
- (BOOL)flipped;
- (BOOL)_setTextureParameters;
- (void)setTextureWrappingMode:(int)fp8;
- (int)textureWrappingMode;
- (void)setTextureFilteringMode:(int)fp8;
- (int)textureFilteringMode;
- (void)setTextureAnisotropy:(float)fp8;
- (float)textureAnisotropy;
- (void)setTextureBorderColor:(CDAnonymousStruct3)fp8;
- (CDAnonymousStruct3)textureBorderColor;
- (unsigned long)textureName;
- (id)bufferData;
- (id)rawData;
- (struct CGImage *)CGImage;
- (id)CIImage;

@end
