#import "QCPatch.h"
#import "QCPatch-Customization.h"
#import "QCOpenGLContext.h"

#import "QCBooleanPort.h"
#import "QCStructurePort.h"
#import "QCIndexPort.h"
#import "QCVirtualPort.h"

@interface StructurePlay : QCPatch
{
    QCStructurePort *inputStruct;
	QCBooleanPort	*inputGate;
	QCIndexPort		*inputPlayMode;
	QCNumberPort	*inputPlaybackRate;
	
    QCVirtualPort	*outputVirtual;
	float			index;
	unsigned int	direction;	// 0 = forwards, 1 = backwards
}

+ (int)executionMode;
+ (BOOL)allowsSubpatches;
+ (int)timeMode;

- (id)initWithIdentifier:(id)fp8;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end